Unit AEG1C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AA02C_p, UTAE10_p;

procedure AEG1C(N :Integer; var AR :Array of Real;
                var AI :Array of Real; var EVR :Array of Real;
                var EVI :Array of Real; var VR :Array of Real;
                var VI :Array of Real; var RAB :Array of Real;
                var IERR :Integer);

implementation

procedure AEG1C(N :Integer; var AR :Array of Real;
                var AI :Array of Real; var EVR :Array of Real;
                var EVI :Array of Real; var VR :Array of Real;
                var VI :Array of Real; var RAB :Array of Real;
                var IERR :Integer);
var
IR1,IR2,A,B,C,D,E,F,G,H,R,S,T,U,V,W,X,Y,Z,BA,BB,BC,BD,BE,BF,NA,NB,NC,
   NR,NT :Integer;
K,L,M,O,P,Q,BG,BH,BJ,BK,BL,BM,BN,BO,BP,BQ,BI,F0,F1,F2,F3 :Real;
BS :Complex;
const
SYS051 :Real = 1.192093E-07;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39,_40,_41,_42,_43,_44,_45,_46,_47,_48,_49,_50,_51,_52,_53,
_54,_55,_56,_57;
begin
IR1 := 1;
IR2 := N;
F := IR2-1;
H := IR1+1;
if ( F < H ) 
 then goto _12;
for C:=H to F do
 begin
  NC := N+C;
  M := 0.0;
  RAB[C-1] := 0.0;
  RAB[NC-1] := 0.0;
  Q := 0.0;
  for A:=C to IR2 do
   begin
_1:
    Q := Q+Abs(AR[(A-1)+(C-2)*N])+Abs(AI[(A-1)+(C-2)*N]);
   end;
  if ( Q = 0.0 ) 
   then goto _11;
  G := C+IR2;
  for D:=C to IR2 do
   begin
    A := G-D;
    NA := N+A;
    RAB[A-1] := AR[(A-1)+(C-2)*N]/Q;
    RAB[NA-1] := AI[(A-1)+(C-2)*N]/Q;
    M := M+RAB[A-1]*RAB[A-1]+RAB[NA-1]*RAB[NA-1];
_2:
   end;
  L := Sqrt(M);
  K := Cabs(Cmplx(RAB[C-1],RAB[NC-1]));
  if ( K = 0.0 ) 
   then goto _3;
  M := M+K*L;
  L := L/K;
  RAB[C-1] := (1.0+L)*RAB[C-1];
  RAB[NC-1] := (1.0+L)*RAB[NC-1];
  goto _4;
_3:
  RAB[C-1] := L;
  AR[(C-1)+(C-2)*N] := Q;
_4:
  for B:=C to N do
   begin
    P := 0.0;
    O := 0.0;
    for D:=C to IR2 do
     begin
      A := G-D;
      NA := N+A;
      P := P+RAB[A-1]*AR[(A-1)+(B-1)*N]+RAB[NA-1]*AI[(A-1)+(B-1)*N];
      O := O+RAB[A-1]*AI[(A-1)+(B-1)*N]-RAB[NA-1]*AR[(A-1)+(B-1)*N];
_5:
     end;
    P := P/M;
    O := O/M;
    for A:=C to IR2 do
     begin
      NA := N+A;
      AR[(A-1)+(B-1)*N] := AR[(A-1)+(B-1)*N]-P*RAB[A-1]+O*RAB[NA-1];
      AI[(A-1)+(B-1)*N] := AI[(A-1)+(B-1)*N]-P*RAB[NA-1]-O*RAB[A-1];
_6:
     end;
_7:
   end;
  for A:=1 to IR2 do
   begin
    P := 0.0;
    O := 0.0;
    for E:=C to IR2 do
     begin
      B := G-E;
      NB := N+B;
      P := P+RAB[B-1]*AR[(A-1)+(B-1)*N]-RAB[NB-1]*AI[(A-1)+(B-1)*N];
      O := O+RAB[B-1]*AI[(A-1)+(B-1)*N]+RAB[NB-1]*AR[(A-1)+(B-1)*N];
_8:
     end;
    P := P/M;
    O := O/M;
    for B:=C to IR2 do
     begin
      NB := N+B;
      AI[(A-1)+(B-1)*N] := AI[(A-1)+(B-1)*N]+P*RAB[NB-1]-O*RAB[B-1];
      AR[(A-1)+(B-1)*N] := AR[(A-1)+(B-1)*N]-P*RAB[B-1]-O*RAB[NB-1];
_9:
     end;
_10:
   end;
  RAB[C-1] := Q*RAB[C-1];
  RAB[NC-1] := Q*RAB[NC-1];
  AR[(C-1)+(C-2)*N] := -L*AR[(C-1)+(C-2)*N];
  AI[(C-1)+(C-2)*N] := -L*AI[(C-1)+(C-2)*N];
_11:
 end;
_12:
IERR := 0;
for R:=1 to N do
 begin
  for S:=1 to N do
   begin
    VR[(R-1)+(S-1)*N] := 0.0;
    VI[(R-1)+(S-1)*N] := 0.0;
    if ( R = S ) 
     then VR[(R-1)+(S-1)*N] := 1.0;
_13:
   end;
 end;
BF := IR2-IR1-1;
if ( BF ) < 0
 then goto _25
 else if ( BF ) > 0
       then goto _14
       else goto _20;
_14:
for X:=1 to BF do
 begin
  R := IR2-X;
  NR := N+R;
  if ( RAB[R-1] = 0.0 ) and ( RAB[NR-1] = 0.0 ) 
   then goto _19;
  if ( AR[(R-1)+(R-2)*N] = 0.0 ) and ( AI[(R-1)+(R-2)*N] = 0.0 ) 
   then goto _19;
  BQ := AR[(R-1)+(R-2)*N]*RAB[R-1]+AI[(R-1)+(R-2)*N]*RAB[NR-1];
  BB := R+1;
  for T:=BB to IR2 do
   begin
    NT := N+T;
    RAB[T-1] := AR[(T-1)+(R-2)*N];
    RAB[NT-1] := AI[(T-1)+(R-2)*N];
_15:
   end;
  for S:=R to IR2 do
   begin
    BH := 0.0;
    BG := 0.0;
    for T:=R to IR2 do
     begin
      NT := N+T;
      BH := BH+RAB[T-1]*VR[(T-1)+(S-1)*N]+RAB[NT-1]*VI[(T-1)+(S-1)*N];
      BG := BG+RAB[T-1]*VI[(T-1)+(S-1)*N]-RAB[NT-1]*VR[(T-1)+(S-1)*N];
_16:
     end;
    BH := BH/BQ;
    BG := BG/BQ;
    for T:=R to IR2 do
     begin
      NT := N+T;
      VR[(T-1)+(S-1)*N] := VR[(T-1)+(S-1)*N]+BH*RAB[T-1]-BG*RAB[NT-1];
      VI[(T-1)+(S-1)*N] := VI[(T-1)+(S-1)*N]+BH*RAB[NT-1]+BG*RAB[T-1];
_17:
     end;
_18:
   end;
_19:
 end;
_20:
U := IR1+1;
for R:=U to IR2 do
 begin
  Z := Min0(R+1,IR2);
  if ( AI[(R-1)+(R-2)*N] = 0.0 ) 
   then goto _24;
  BQ := Cabs(Cmplx(AR[(R-1)+(R-2)*N],AI[(R-1)+(R-2)*N]));
  BN := AR[(R-1)+(R-2)*N]/BQ;
  BM := AI[(R-1)+(R-2)*N]/BQ;
  AR[(R-1)+(R-2)*N] := BQ;
  AI[(R-1)+(R-2)*N] := 0.0;
  for S:=R to N do
   begin
    BG := BN*AI[(R-1)+(S-1)*N]-BM*AR[(R-1)+(S-1)*N];
    AR[(R-1)+(S-1)*N] := BN*AR[(R-1)+(S-1)*N]+BM*AI[(R-1)+(S-1)*N];
    AI[(R-1)+(S-1)*N] := BG;
_21:
   end;
  for S:=1 to Z do
   begin
    BG := BN*AI[(S-1)+(R-1)*N]+BM*AR[(S-1)+(R-1)*N];
    AR[(S-1)+(R-1)*N] := BN*AR[(S-1)+(R-1)*N]-BM*AI[(S-1)+(R-1)*N];
    AI[(S-1)+(R-1)*N] := BG;
_22:
   end;
  for S:=IR1 to IR2 do
   begin
    BG := BN*VI[(S-1)+(R-1)*N]+BM*VR[(S-1)+(R-1)*N];
    VR[(S-1)+(R-1)*N] := BN*VR[(S-1)+(R-1)*N]-BM*VI[(S-1)+(R-1)*N];
    VI[(S-1)+(R-1)*N] := BG;
_23:
   end;
_24:
 end;
_25:
for R:=1 to N do
 begin
  if ( R >= IR1 ) and ( R <= IR2 ) 
   then goto _26;
  EVR[R-1] := AR[(R-1)+(R-1)*N];
  EVI[R-1] := AI[(R-1)+(R-1)*N];
_26:
 end;
W := IR2;
BJ := 0.0;
BI := 0.0;
_27:
if ( W < IR1 ) 
 then goto _46;
BC := 0;
BE := W-1;
_28:
for Z:=IR1 to W do
 begin
  U := W+IR1-Z;
  if ( U = IR1 ) 
   then goto _30;
  if ( Abs(AR[(U-1)+(U-2)*N]) <= SYS051*(Abs(AR[(U-2)+(U-2)*N])+
       Abs(AI[(U-2)+(U-2)*N])+Abs(AR[(U-1)+(U-1)*N])+Abs(AI[(U-1)+(U-1)*N])) ) 
   then goto _30;
_29:
 end;
_30:
if ( U = W ) 
 then goto _45;
if ( BC = 30 ) 
 then goto _56;
if ( BC = 10 ) or ( BC = 20 ) 
 then goto _32;
BH := AR[(W-1)+(W-1)*N];
BG := AI[(W-1)+(W-1)*N];
BL := AR[(BE-1)+(W-1)*N]*AR[(W-1)+(BE-1)*N];
BK := AI[(BE-1)+(W-1)*N]*AR[(W-1)+(BE-1)*N];
if ( BL = 0.0 ) and ( BK = 0.0 ) 
 then goto _33;
BN := (AR[(BE-1)+(BE-1)*N]-BH)/2.0;
BM := (AI[(BE-1)+(BE-1)*N]-BG)/2.0;
BS := Csqrt(Cmplx(IntPower(BN,2)-IntPower(BM,2)+BL,2.0*BN*BM+BK));
BP := Creal(BS);
BO := Aimag(BS);
if ( BN*BP+BM*BO >= 0.0 ) 
 then goto _31;
BP := -BP;
BO := -BO;
_31:
AA02C(BL,BK,BN+BP,BM+BO,F1,F2);
BH := BH-F1;
BG := BG-F2;
goto _33;
_32:
BH := Abs(AR[(W-1)+(BE-1)*N])+Abs(AR[(BE-1)+(W-3)*N]);
BG := 0.0;
_33:
for R:=IR1 to W do
 begin
  AR[(R-1)+(R-1)*N] := AR[(R-1)+(R-1)*N]-BH;
  AI[(R-1)+(R-1)*N] := AI[(R-1)+(R-1)*N]-BG;
_34:
 end;
BJ := BJ+BH;
BI := BI+BG;
BC := BC+1;
BD := U+1;
for R:=BD to W do
 begin
  BH := AR[(R-1)+(R-2)*N];
  AR[(R-1)+(R-2)*N] := 0.0;
  F1 := Abs(AR[(R-2)+(R-2)*N]);
  F2 := Abs(AI[(R-2)+(R-2)*N]);
  F3 := Abs(BH);
  F0 := F1;
  if ( F0 < F2 ) 
   then F0 := F2;
  if ( F0 < F3 ) 
   then F0 := F3;
  F1 := F1/F0;
  F2 := F2/F0;
  F3 := F3/F0;
  BQ := F0*Sqrt(F1*F1+F2*F2+F3*F3);
  BL := AR[(R-2)+(R-2)*N]/BQ;
  EVR[R-2] := BL;
  BK := AI[(R-2)+(R-2)*N]/BQ;
  EVI[R-2] := BK;
  AR[(R-2)+(R-2)*N] := BQ;
  AI[(R-2)+(R-2)*N] := 0.0;
  AI[(R-1)+(R-2)*N] := BH/BQ;
  for S:=R to N do
   begin
    BN := AR[(R-2)+(S-1)*N];
    BM := AI[(R-2)+(S-1)*N];
    BP := AR[(R-1)+(S-1)*N];
    BO := AI[(R-1)+(S-1)*N];
    AR[(R-2)+(S-1)*N] := BL*BN+BK*BM+AI[(R-1)+(R-2)*N]*BP;
    AI[(R-2)+(S-1)*N] := BL*BM-BK*BN+AI[(R-1)+(R-2)*N]*BO;
    AR[(R-1)+(S-1)*N] := BL*BP-BK*BO-AI[(R-1)+(R-2)*N]*BN;
    AI[(R-1)+(S-1)*N] := BL*BO+BK*BP-AI[(R-1)+(R-2)*N]*BM;
_35:
   end;
_36:
 end;
BG := AI[(W-1)+(W-1)*N];
if ( BG = 0.0 ) 
 then goto _38;
BQ := Cabs(Cmplx(AR[(W-1)+(W-1)*N],BG));
BH := AR[(W-1)+(W-1)*N]/BQ;
BG := BG/BQ;
AR[(W-1)+(W-1)*N] := BQ;
AI[(W-1)+(W-1)*N] := 0.0;
if ( W = N ) 
 then goto _38;
BB := W+1;
for S:=BB to N do
 begin
  BN := AR[(W-1)+(S-1)*N];
  BM := AI[(W-1)+(S-1)*N];
  AR[(W-1)+(S-1)*N] := BH*BN+BG*BM;
  AI[(W-1)+(S-1)*N] := BH*BM-BG*BN;
_37:
 end;
_38:
for S:=BD to W do
 begin
  BL := EVR[S-2];
  BK := EVI[S-2];
  for R:=1 to S do
   begin
    BN := AR[(R-1)+(S-2)*N];
    BM := 0.0;
    BP := AR[(R-1)+(S-1)*N];
    BO := AI[(R-1)+(S-1)*N];
    if ( R = S ) 
     then goto _39;
    BM := AI[(R-1)+(S-2)*N];
    AI[(R-1)+(S-2)*N] := BL*BM+BK*BN+AI[(S-1)+(S-2)*N]*BO;
_39:
    AR[(R-1)+(S-2)*N] := BL*BN-BK*BM+AI[(S-1)+(S-2)*N]*BP;
    AR[(R-1)+(S-1)*N] := BL*BP+BK*BO-AI[(S-1)+(S-2)*N]*BN;
    AI[(R-1)+(S-1)*N] := BL*BO-BK*BP-AI[(S-1)+(S-2)*N]*BM;
_40:
   end;
  for R:=IR1 to IR2 do
   begin
    BN := VR[(R-1)+(S-2)*N];
    BM := VI[(R-1)+(S-2)*N];
    BP := VR[(R-1)+(S-1)*N];
    BO := VI[(R-1)+(S-1)*N];
    VR[(R-1)+(S-2)*N] := BL*BN-BK*BM+AI[(S-1)+(S-2)*N]*BP;
    VI[(R-1)+(S-2)*N] := BL*BM+BK*BN+AI[(S-1)+(S-2)*N]*BO;
    VR[(R-1)+(S-1)*N] := BL*BP+BK*BO-AI[(S-1)+(S-2)*N]*BN;
    VI[(R-1)+(S-1)*N] := BL*BO-BK*BP-AI[(S-1)+(S-2)*N]*BM;
_41:
   end;
_42:
 end;
if ( BG = 0.0 ) 
 then goto _28;
for R:=1 to W do
 begin
  BN := AR[(R-1)+(W-1)*N];
  BM := AI[(R-1)+(W-1)*N];
  AR[(R-1)+(W-1)*N] := BH*BN-BG*BM;
  AI[(R-1)+(W-1)*N] := BH*BM+BG*BN;
_43:
 end;
for R:=IR1 to IR2 do
 begin
  BN := VR[(R-1)+(W-1)*N];
  BM := VI[(R-1)+(W-1)*N];
  VR[(R-1)+(W-1)*N] := BH*BN-BG*BM;
  VI[(R-1)+(W-1)*N] := BH*BM+BG*BN;
_44:
 end;
goto _28;
_45:
AR[(W-1)+(W-1)*N] := AR[(W-1)+(W-1)*N]+BJ;
EVR[W-1] := AR[(W-1)+(W-1)*N];
AI[(W-1)+(W-1)*N] := AI[(W-1)+(W-1)*N]+BI;
EVI[W-1] := AI[(W-1)+(W-1)*N];
W := BE;
goto _27;
_46:
BQ := 0.0;
for R:=1 to N do
 begin
  for S:=R to N do
   begin
    BQ := BQ+Abs(AR[(R-1)+(S-1)*N])+Abs(AI[(R-1)+(S-1)*N]);
_47:
   end;
 end;
if ( N = 1 ) or ( BQ = 0.0 ) 
 then goto _57;
for BA:=2 to N do
 begin
  W := N+2-BA;
  BL := EVR[W-1];
  BK := EVI[W-1];
  BE := W-1;
  for X:=1 to BE do
   begin
    R := W-X;
    BP := AR[(R-1)+(W-1)*N];
    BO := AI[(R-1)+(W-1)*N];
    if ( R = BE ) 
     then goto _49;
    BB := R+1;
    for S:=BB to BE do
     begin
      BP := BP+AR[(R-1)+(S-1)*N]*AR[(S-1)+(W-1)*N]-AI[(R-1)+(S-1)*N]*AI[(S-1)+(W-1)*N];
      BO := BO+AR[(R-1)+(S-1)*N]*AI[(S-1)+(W-1)*N]+AI[(R-1)+(S-1)*N]*AR[(S-1)+(W-1)*N];
_48:
     end;
_49:
    BN := BL-EVR[R-1];
    BM := BK-EVI[R-1];
    if ( BN = 0.0 ) and ( BM = 0.0 ) 
     then BN := SYS051*BQ;
    AA02C(BP,BO,BN,BM,AR[(R-1)+(W-1)*N],AI[(R-1)+(W-1)*N]);
_50:
   end;
_51:
 end;
BE := N-1;
for R:=1 to BE do
 begin
  if ( R >= IR1 ) and ( R <= IR2 ) 
   then goto _53;
  BB := R+1;
  for S:=BB to N do
   begin
    VR[(R-1)+(S-1)*N] := AR[(R-1)+(S-1)*N];
    VI[(R-1)+(S-1)*N] := AI[(R-1)+(S-1)*N];
_52:
   end;
_53:
 end;
for Y:=IR1 to BE do
 begin
  S := N+IR1-Y;
  V := Min0(S-1,IR2);
  for R:=IR1 to IR2 do
   begin
    BP := VR[(R-1)+(S-1)*N];
    BO := VI[(R-1)+(S-1)*N];
    for T:=IR1 to V do
     begin
      BP := BP+VR[(R-1)+(T-1)*N]*AR[(T-1)+(S-1)*N]-VI[(R-1)+(T-1)*N]*AI[(T-1)+(S-1)*N];
      BO := BO+VR[(R-1)+(T-1)*N]*AI[(T-1)+(S-1)*N]+VI[(R-1)+(T-1)*N]*AR[(T-1)+(S-1)*N];
_54:
     end;
    VR[(R-1)+(S-1)*N] := BP;
    VI[(R-1)+(S-1)*N] := BO;
_55:
   end;
 end;
goto _57;
_56:
IERR := W;
_57:
if ( IERR <> 0 ) 
 then UTAE10(IERR,N,10);
end;

end.
